#include <dpf-internal.h>

void dpf_printir(struct dpf_ir *ir) {
	int i, n, bits;
	struct eq *e;
	struct shift *s;

	printf("Dumping filter, has %d atoms:\n", ir->irn);
	for(i = 0, n = ir->irn; i < n; i++) {
		e = &ir->ir[i].u.eq;
		s = &ir->ir[i].u.shift;
		bits = e->nbits;

		if(e->op == DPF_OP_EQ) {
                	printf("\tmsg[%d:%d] & 0x%x == 0x%x",
					e->offset, bits, e->mask, e->val);
		} else {
  			printf("\tmsg + msg[%d:%d] & 0x%x << %d",
                		s->offset, bits, s->mask, s->shift);
		}
		if(n > 1 && i != (n - 1))
			printf("\t&&\n");
	}
	printf("\n");
}
